'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formPropTypes = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _disabledProps = require('./disabled-props');

var _disabledProps2 = _interopRequireDefault(_disabledProps);

var _messageProps = require('./message-props');

var _messageProps2 = _interopRequireDefault(_messageProps);

var _hookProps = require('./hook-props');

var _hookProps2 = _interopRequireDefault(_hookProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//------------------------------------------------------------------------------
// PROPS AND METHODS PROVIDER:
//------------------------------------------------------------------------------
var FormProps = function FormProps(_ref) {
  var children = _ref.children;
  return _react2.default.createElement(
    _disabledProps2.default,
    null,
    function (disabledProps) {
      return _react2.default.createElement(
        _messageProps2.default,
        null,
        function (messageProps) {
          return _react2.default.createElement(
            _hookProps2.default,
            {
              disabledProps: disabledProps,
              messageProps: messageProps
            },
            function (hookProps) {
              // Public API
              var api = {
                disabled: disabledProps.disabled,
                errorMsg: messageProps.errorMsg,
                successMsg: messageProps.successMsg,
                setSuccessMessage: messageProps.setSuccessMessage,
                clearMessages: messageProps.clearMessages,
                handleBefore: hookProps.handleBefore,
                handleClientError: hookProps.handleClientError,
                handleServerError: hookProps.handleServerError,
                handleSuccess: hookProps.handleSuccess
              };

              return children(api);
            }
          );
        }
      );
    }
  );
};

FormProps.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object]).isRequired
};

exports.default = FormProps;

//------------------------------------------------------------------------------
// PROP TYPES:
//------------------------------------------------------------------------------

var formPropTypes = exports.formPropTypes = _extends({
  disabled: _disabledProps.disabledPropTypes.disabled,
  errorMsg: _messageProps.messagePropTypes.errorMsg,
  successMsg: _messageProps.messagePropTypes.successMsg,
  setSuccessMessage: _messageProps.messagePropTypes.setSuccessMessage,
  clearMessages: _messageProps.messagePropTypes.clearMessages
}, _hookProps.hookPropTypes);