'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hookPropTypes = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _disabledProps = require('./disabled-props');

var _messageProps = require('./message-props');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//------------------------------------------------------------------------------
// PROPS AND METHODS PROVIDER:
//------------------------------------------------------------------------------
var HookProps = function (_React$PureComponent) {
  _inherits(HookProps, _React$PureComponent);

  function HookProps() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, HookProps);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = HookProps.__proto__ || Object.getPrototypeOf(HookProps)).call.apply(_ref, [this].concat(args))), _this), _this.handleBefore = function (cb) {
      var _this$props = _this.props,
          disabledProps = _this$props.disabledProps,
          messageProps = _this$props.messageProps;

      disabledProps.disableBtn();
      messageProps.clearMessages();
      // Allow other components to extend handleBefore default functionality
      if (cb && typeof cb === 'function') {
        cb();
      }
    }, _this.handleClientError = function (err) {
      // eslint-disable-line no-unused-vars
      var disabledProps = _this.props.disabledProps;
      // console.log(err);

      disabledProps.enableBtn();
    }, _this.handleServerError = function (err) {
      var _this$props2 = _this.props,
          disabledProps = _this$props2.disabledProps,
          messageProps = _this$props2.messageProps;
      // console.log(err);

      messageProps.setErrorMessage(err.reason || err.message || 'Unexpected error');
      disabledProps.enableBtn();
    }, _this.handleSuccess = function (cb) {
      var _this$props3 = _this.props,
          disabledProps = _this$props3.disabledProps,
          messageProps = _this$props3.messageProps;

      disabledProps.enableBtn();
      messageProps.clearMessages();
      // Allow other components to extend handleBefore default functionality
      if (cb && typeof cb === 'function') {
        cb();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(HookProps, [{
    key: 'render',
    value: function render() {
      var children = this.props.children;

      // Public API

      var api = {
        handleBefore: this.handleBefore,
        handleClientError: this.handleClientError,
        handleServerError: this.handleServerError,
        handleSuccess: this.handleSuccess
      };

      return children(api);
    }
  }]);

  return HookProps;
}(_react2.default.PureComponent);

HookProps.propTypes = {
  disabledProps: _propTypes2.default.shape(_disabledProps.disabledPropTypes).isRequired,
  messageProps: _propTypes2.default.shape(_messageProps.messagePropTypes).isRequired,
  children: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object]).isRequired
};

exports.default = HookProps;

//------------------------------------------------------------------------------
// PROP TYPES:
//------------------------------------------------------------------------------

var hookPropTypes = exports.hookPropTypes = {
  handleBefore: _propTypes2.default.func.isRequired,
  handleClientError: _propTypes2.default.func.isRequired,
  handleServerError: _propTypes2.default.func.isRequired,
  handleSuccess: _propTypes2.default.func.isRequired
};