'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pwaBtnPropTypes = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//------------------------------------------------------------------------------
// PROPS AND METHODS PROVIDER:
//------------------------------------------------------------------------------
var PWABtnProps = function (_React$PureComponent) {
  _inherits(PWABtnProps, _React$PureComponent);

  function PWABtnProps() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, PWABtnProps);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PWABtnProps.__proto__ || Object.getPrototypeOf(PWABtnProps)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      supported: 'loading', // whether or not push notifications are supported
      subscribed: 'loading' // whether or not the user is subscribe to push notifications
    }, _this.setSupported = function (supported) {
      _this.setState(function () {
        return { supported: supported };
      });
    }, _this.setSubscribed = function (subscribed) {
      _this.setState(function () {
        return { subscribed: subscribed };
      });
    }, _this.initialiseState = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var registration, subscription;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if ('showNotification' in ServiceWorkerRegistration.prototype) {
                _context.next = 5;
                break;
              }

              console.log('Notifications aren\'t supported.');
              _this.setSupported(false);
              _this.setSubscribed(false);
              return _context.abrupt('return');

            case 5:
              if (!(Notification.permission === 'denied')) {
                _context.next = 10;
                break;
              }

              console.log('The user has blocked notifications.');
              _this.setSupported(false);
              _this.setSubscribed(false);
              return _context.abrupt('return');

            case 10:
              if ('PushManager' in window) {
                _context.next = 15;
                break;
              }

              console.log('Push messaging isn\'t supported.');
              _this.setSupported(false);
              _this.setSubscribed(false);
              return _context.abrupt('return');

            case 15:
              _context.prev = 15;
              _context.next = 18;
              return navigator.serviceWorker.ready;

            case 18:
              registration = _context.sent;
              _context.next = 21;
              return registration.pushManager.getSubscription();

            case 21:
              subscription = _context.sent;


              // Enable any UI which subscribes / unsubscribes from push messages
              _this.setSupported(true);

              if (subscription) {
                _context.next = 26;
                break;
              }

              // We aren’t subscribed to push, so set UI to allow the user to enable
              // push
              _this.setSubscribed(false);
              return _context.abrupt('return');

            case 26:

              // Set your UI to show they have subscribed for push messages
              _this.setSubscribed(true);
              _context.next = 32;
              break;

            case 29:
              _context.prev = 29;
              _context.t0 = _context['catch'](15);

              console.log('Error during getSubscription()', _context.t0);

            case 32:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2, [[15, 29]]);
    })), _this.handleSubscriptionChange = function (_ref3) {
      var subscribed = _ref3.subscribed;

      _this.setSubscribed(subscribed);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(PWABtnProps, [{
    key: 'componentDidMount',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!('serviceWorker' in navigator)) {
                  _context2.next = 12;
                  break;
                }

                _context2.prev = 1;
                _context2.next = 4;
                return navigator.serviceWorker.ready;

              case 4:
                // Once the service worker is registered set the initial button state
                this.initialiseState();
                _context2.next = 10;
                break;

              case 7:
                _context2.prev = 7;
                _context2.t0 = _context2['catch'](1);

                console.log(_context2.t0);

              case 10:
                _context2.next = 15;
                break;

              case 12:
                this.setSupported(false);
                this.setSubscribed(false);
                console.log('Service workers aren\'t supported in this browser.');

              case 15:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[1, 7]]);
      }));

      function componentDidMount() {
        return _ref4.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;
      var _state = this.state,
          supported = _state.supported,
          subscribed = _state.subscribed;

      // Public API

      var api = {
        supported: supported,
        subscribed: subscribed,
        handleSubscriptionChange: this.handleSubscriptionChange
      };

      return children(api);
    }
  }]);

  return PWABtnProps;
}(_react2.default.PureComponent);

PWABtnProps.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object]).isRequired
};

exports.default = PWABtnProps;

//------------------------------------------------------------------------------
// PROP TYPES:
//------------------------------------------------------------------------------

var pwaBtnPropTypes = exports.pwaBtnPropTypes = {
  supported: _propTypes2.default.oneOf([true, false, 'loading']).isRequired,
  subscribed: _propTypes2.default.oneOf([true, false, 'loading']).isRequired,
  handleSubscriptionChange: _propTypes2.default.func.isRequired
};